<?php
namespace Teknisa\PLA\Controllers;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Controller\Simple;

class CalculaNutrientes extends Simple{

    /** @var Connection */
    protected $connection;
    protected $novoCodigo;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function calcularNutrientes(\Zeedhi\Framework\DTO\Request\Filter $request,
    	\Zeedhi\Framework\DTO\Response $response) {

        $conditions = $request->getFilterCriteria()->getConditions();

        $cdfilial = $conditions[0]['value'];
        $cdservfili = $conditions[1]['value'];
        $dtinicial = $conditions[2]['value'];
        $dtfinal = $conditions[3]['value'];
        $contador = "CALCNUTR".$cdfilial;

        $connection = $this->connection;

        $procedureNovoCodigo = new \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure($connection, 'NOVO_CODIGO');
        $procedureNovoCodigo->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_CONTADOR', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $contador, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR, strlen($contador)));
        $procedureNovoCodigo->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_SEQUENCIAL', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_OUTPUT, null, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_INT, 20));
        $procedureNovoCodigo->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_NRORG', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, 1, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_INT));
        $result = $procedureNovoCodigo->execute();
        
        $nrsequnutr = substr($result['P_SEQUENCIAL'], strlen($result['P_SEQUENCIAL']) - 10);

        $procedureNutriente = new \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure($connection, 'NUTRIENTE_DO_CARDAPIO_PLA');
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_FILIAL', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $cdfilial, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_SERVICOS', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $cdservfili, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_NUTRIENTES', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, null, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_NRSEQUNUTR', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $nrsequnutr, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_IDNDPCAL', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, "S", \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_DTINICIAL', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $dtinicial, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new \Zeedhi\Framework\DB\StoredProcedure\Param('P_DTFINAL', \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_INPUT, $dtfinal, \Zeedhi\Framework\DB\StoredProcedure\Param::PARAM_TYPE_STR));
        $procedureNutriente->execute();

        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet ('nrsequnutr', array($nrsequnutr)));

    }

}