<?php
namespace Teknisa\PLA\Modules\Relatorio\Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\Environment;
use TecFood\Services\User as UserService;

class Pla01303EmissaoDasReceitasService {
    
    protected $connection;

    public function __construct($entityManager){
        $this->connection = $entityManager->getConnection();
    }

	public function returnFilial($params){
        $sqlFilial = "SELECT DISTINCT F.CDFILIAL AS CDFILIAL FROM FILIAL F INNER JOIN FILIOPER FO ON FO.NRORG = F.NRORG AND FO.CDFILIAL = F.CDFILIAL LEFT JOIN FILGRUPFILI FG ON F.NRORG = FG.NRORG AND F.CDFILIAL = FG.CDFILIAL WHERE F.NRORG = :NRORG AND FO.CDOPERADOR = :CDOPERADOR AND ( :CDGRUPFILI = FG.CDGRUPFILI OR :CDGRUPFILI = 'T' ) ORDER BY CDFILIAL";
        
        try{
            $std = $this->connection->prepare($sqlFilial);
            $std->execute($params);
            $cdFiliServ = $std->fetchAll();
            $cdFiliServ = (array_column($cdFiliServ, 'CDFILIAL'));
            return $cdFiliServ;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function returnFiliServ($params){
        $sqlFiliServ = "SELECT DISTINCT (F.CDFILIAL || S.CDSERVFILI) AS CDFILISERV FROM FILIAL F INNER JOIN FILIOPER FO ON FO.NRORG = F.NRORG AND FO.CDFILIAL = F.CDFILIAL LEFT JOIN FILGRUPFILI FG ON F.NRORG = FG.NRORG AND F.CDFILIAL = FG.CDFILIAL RIGHT JOIN SERVICO S ON F.CDFILIAL = S.CDFILIAL WHERE F.NRORG = :NRORG AND FO.CDOPERADOR = :CDOPERADOR AND ( :CDGRUPFILI = FG.CDGRUPFILI OR :CDGRUPFILI = 'T' ) AND VALOR_NA_LISTA(F.CDFILIAL, :CDFILIAL) <> 0 ORDER BY 1";
        
        try{
            $std = $this->connection->prepare($sqlFiliServ);
            $std->execute($params);
            $cdFiliServ = $std->fetchAll();
            $cdFiliServ = (array_column($cdFiliServ, 'CDFILISERV'));
            return $cdFiliServ;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}